<template lang="pug">
transition-group(:name="props.anim" :appear="props.appear" :tag="props.tag"
                 @enter="onEnter" @leave="onLeave" )
  slot
</template>
<script setup>

import { computed, defineEmits, defineProps } from "vue";
import Anim from "./BaseAnimation.js";

/**
 * @typedef {import('vue').VNode} VNode
 * @typedef {import('vue').ComponentPublicInstance} ComponentPublicInstance
 * @typedef {import('./BaseAnimation.js').Anim} AnimType
 * @typedef {import('./BaseAnimation.js').AnimOptions} AnimOptions
 */

const props = defineProps({
  tag: { type: String, default: "span" },
  appear: { type: Boolean, default: true },
  anim: {
    type: /** @type {V.PropType<keyof Anim>} */ (String),
    default: Anim.default
  }
});

const emit = defineEmits([ "onEnter", "onLeave" ]);

const animation = computed(
  () => /** @type {AnimType} */ (Anim[/** @type {keyof Anim} */ (props.anim)] ?? {}));

const options = computed(
  () => ({ appear: props.appear }));

/**
 * @param {VNode|ComponentPublicInstance|Element} elt
 * @param {function} done
 */
function onEnter(elt, done) {
  emit("onEnter", elt);
  const eltDom = Anim.getDom(elt);
  const anim = /** @type {AnimType} */ (Anim?.[/** @type {keyof Anim} */ (eltDom?.getAttribute("anim")) ?? ""]) ?? animation.value;
  if (anim?.in) {
    anim.in(eltDom, options.value, done);
  }
  else {
    done();
  }
}

/**
 * @param {VNode|ComponentPublicInstance|Element} elt
 * @param {function} done
 */
function onLeave(elt, done) {
  emit("onLeave", elt);
  const eltDom = Anim.getDom(elt);
  const anim = /** @type {AnimType} */ (Anim?.[/** @type {keyof Anim} */ (eltDom?.getAttribute("anim")) ?? ""]) ?? animation.value;
  if (anim?.out) {
    anim.out(eltDom, options.value, done);
  }
  else {
    done();
  }
}

</script>
